package org.sky.resource.builder;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.AllArgsConstructor;
import org.sky.core.cache.utils.CacheUtil;
import org.sky.core.literule.engine.RuleEngineExecutor;
import org.sky.core.literule.provider.LiteRuleResponse;
import org.sky.core.log.exception.ServiceException;
import org.sky.core.oss.OssTemplate;
import org.sky.core.oss.enums.OssEnum;
import org.sky.core.oss.enums.OssStatusEnum;
import org.sky.core.oss.props.OssProperties;
import org.sky.core.secure.utils.AuthUtil;
import org.sky.core.tool.utils.StringPool;
import org.sky.core.tool.utils.StringUtil;
import org.sky.core.tool.utils.WebUtil;
import org.sky.resource.pojo.entity.Oss;
import org.sky.resource.rule.context.OssContext;
import org.sky.resource.service.IOssService;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import static org.sky.core.cache.constant.CacheConstant.RESOURCE_CACHE;
import static org.sky.resource.rule.constant.OssRuleConstant.OSS_CHAIN_ID;

/**
 * Oss云存储统一构建类
 *
 */
@AllArgsConstructor
public class OssBuilder {

	public static final String OSS_CODE = "oss:code:";
	public static final String OSS_PARAM_KEY = "code";

	private final OssProperties ossProperties;
	private final IOssService ossService;
	private final RuleEngineExecutor ruleExecutor;

	/**
	 * OssTemplate配置缓存池
	 */
	private final Map<String, OssTemplate> templatePool = new ConcurrentHashMap<>();

	/**
	 * oss配置缓存池
	 */
	private final Map<String, Oss> ossPool = new ConcurrentHashMap<>();

	/**
	 * 获取template
	 *
	 * @return OssTemplate
	 */
	public OssTemplate template() {
		return template(StringPool.EMPTY);
	}

	/**
	 * 获取template
	 *
	 * @param code 资源编号
	 * @return OssTemplate
	 */
	public OssTemplate template(String code) {
		String tenantId = AuthUtil.getTenantId();
		return template(tenantId, code);
	}

	/**
	 * 获取template
	 *
	 * @param tenantId 租户ID
	 * @param code     资源编号
	 * @return OssTemplate
	 */
	public OssTemplate template(String tenantId, String code) {
		Oss oss = getOss(tenantId, code);

		OssContext ossContext = new OssContext();
		ossContext.setOss(oss);
		ossContext.setOssProperties(ossProperties);
		ossContext.setOssPool(ossPool);
		ossContext.setTemplatePool(templatePool);

		LiteRuleResponse<OssContext> resp = ruleExecutor.execute(OSS_CHAIN_ID, tenantId, ossContext);
		if (resp.isSuccess()) {
			OssContext contextBean = resp.getContext();
			return contextBean.getOssTemplate();
		} else {
			throw new ServiceException("未获取到对应的对象存储配置");
		}
	}

	/**
	 * 获取对象存储实体
	 *
	 * @param tenantId 租户ID
	 * @return Oss
	 */
	public Oss getOss(String tenantId, String code) {
		String key = tenantId;
		LambdaQueryWrapper<Oss> lqw = Wrappers.<Oss>query().lambda().eq(Oss::getTenantId, tenantId);
		// 获取传参的资源编号并查询，若有则返回，若没有则调启用的配置
		String ossCode = StringUtil.isBlank(code) ? WebUtil.getParameter(OSS_PARAM_KEY) : code;
		if (StringUtil.isNotBlank(ossCode)) {
			key = key.concat(StringPool.DASH).concat(ossCode);
			lqw.eq(Oss::getOssCode, ossCode);
		} else {
			lqw.eq(Oss::getStatus, OssStatusEnum.ENABLE.getNum());
		}
		Oss oss = CacheUtil.get(RESOURCE_CACHE, OSS_CODE, key, () -> {
			Oss o = ossService.getOne(lqw);
			// 若为空则调用默认配置
			if (o == null || o.getId() == null) {
				Oss defaultOss = new Oss();
				defaultOss.setId(0L);
				defaultOss.setCategory(OssEnum.of(ossProperties.getName()).getCategory());
				defaultOss.setEndpoint(ossProperties.getEndpoint());
				defaultOss.setTransformEndpoint(ossProperties.getTransformEndpoint());
				defaultOss.setBucketName(ossProperties.getBucketName());
				defaultOss.setAccessKey(ossProperties.getAccessKey());
				defaultOss.setSecretKey(ossProperties.getSecretKey());
				return defaultOss;
			} else {
				return o;
			}
		});
		if (oss == null || oss.getId() == null) {
			throw new ServiceException("未获取到对应的对象存储配置");
		} else {
			return oss;
		}
	}

}
